ifdef isplus
building_transp_col:
    ; BUILDING ID, DAY PEN
    ;   -GRB
  defw &0500;9,  0   ; 0  - GRASS            - GREEN
  defw &0050;3,  0   ; 1  - CABIN            - BROWN
  defw &0000;0,  0   ; 2  - MINE             - BLACK
  defw &06F0;15, 3   ; 3  - WIGWAM           - ORANGE
  defw &0000;0,  0   ; 4  - STONE BUILDING   - BLACK
  defw &06F0;0,  0   ; 5  - MINE             - ORANGE
  defw &06F0;0,  0   ; 6  - MINE2            - ORANGE
  defw &0050;3,  0   ; 7  - WESTERN SHOP     - BROWN
  defw &0050;3,  0   ; 8  - WESTERN SALOON   - BROWN
  defw &0000;0,  0   ; 9  - CHURCH           - BLACK
  defw &06F0;15, 3   ; 10 - SHIP WHEEL HOUSE - ORANGE
  defw &0000;0,  0   ; 11 - IN DUNGEON       - BLACK
  defw &0000;0,  0   ; 12 - IN BASEMENT      - BLACK
  defw &0050;3,  0   ; 13 - IN JAIL          - BROWN
  defw &0050;3,  0   ; 14 - IN BANK          - BROWN
  defw &0050;0,  0   ; 15 - WESTERN HOTEL    - BROWN
  defw &050C;3,  0   ; 16 - CABIN UNDER WATER  BLUE
  defw &0000;0,  0   ; 17 - CAVE             - BLACK
  defw &0000;0,  0   ; 18 - IN OUTHOUSE      - BLACK
  defw &0000;0,  0   ; 19 - IN OUTHOUSE 2    - BLACK
  defw &06F0;15, 3   ; 20 - SHIP SUNKEN      - ORANGE
  defw &06F0;15, 3   ; 21 - SHIP SUNKEN 2    - ORANGE
  defw &0000;0,  0   ; 22 - IN GRAVE         - BLACK
endif

ifndef isplus
building_transp_col:
  ; BUILDING ID, DAY, NIGHT PEN
  ; LEFT 4 BITS = DAY PEN, RIGHT 4 BITS = NIGHT PEN
  defb %10010000;9,  0   ; 0  - GRASS            - GREEN,  BLACK
  defb %00110000;3,  0   ; 1  - CABIN            - BROWN,  BLACK
  defb %00000000;0,  0   ; 2  - MINE             - BLACK,  BLACK
  defb %11110011;15, 3   ; 3  - WIGWAM           - ORANGE, BROWN
  defb %00000000;0,  0   ; 4  - STONE BUILDING   - BLACK,  BLACK
  defb %00000000;0,  0   ; 5  - MINE             - ORANGE, BLACK
  defb %00000000;0,  0   ; 6  - MINE2            - ORANGE, BLACK
  defb %00110011;3,  0   ; 7  - WESTERN SHOP     - BROWN,  BROWN
  defb %00110011;3,  0   ; 8  - WESTERN SALOON   - BROWN,  BROWN
  defb %00000000;0,  0   ; 9  - CHURCH           - BLACK,  BLACK
  defb %11110011;15, 3   ; 10 - SHIP WHEEL HOUSE - ORANGE, BROWN
  defb %00000000;0,  0   ; 11 - IN DUNGEON       - BLACK,  BLACK
  defb %00000000;0,  0   ; 12 - IN BASEMENT      - BLACK,  BLACK
  defb %00110000;3,  0   ; 13 - IN JAIL          - BROWN,  BLACK
  defb %00110000;3,  0   ; 14 - IN BANK          - BROWN,  BLACK 
  defb %00110011;0,  0   ; 15 - WESTERN HOTEL    - BROWN,  BROWN
  defb %11100000;3,  0   ; 16 - CABIN UNDER WATER  BLUE,   BLACK
  defb %00000000;0,  0   ; 17 - CAVE             - BLACK,  BLACK
  defb %00000000;0,  0   ; 18 - IN OUTHOUSE      - BLACK,  BLACK
  defb %00000000;0,  0   ; 19 - IN OUTHOUSE 2    - BLACK,  BLACK
  defb %11110011;15, 3   ; 20 - SHIP SUNKEN      - ORANGE, BROWN
  defb %11110011;15, 3   ; 21 - SHIP SUNKEN 2    - ORANGE, BROWN
  defb %00000000;0,  0   ; 19 - IN GRAVE         - BLACK,  BLACK
endif

; BUILDING CODES LISTED BY BUILDING ID
buildinglist:
  defw skipbuildingcheck       ;  0
  defw inlogcabin              ;  1
  defw inmine                  ;  2
  defw inwigwam                ;  3
  defw instonebuilding         ;  4
  defw buildroommine2          ;  5
  defw buildroommine2reverse   ;  6
  defw inlogcabinwesternshop   ;  7
  defw inlogcabinwesternsaloon ;  8
  defw inchurch                ;  9
  defw inship                  ; 10
  defw indungeon               ; 11
  defw inbasement              ; 12
  defw buildroomjail           ; 13
  defw inbank                  ; 14
  defw inhotelbedroom          ; 15
  defw inlogcabinunderwater    ; 16
  defw incave                  ; 17
  defw inouthouse              ; 18
  defw inouthouse2             ; 19
  defw inshipsunken            ; 20
  defw inshipsunken2           ; 21
  defw ingrave                 ; 22

; ------------ WOODEN ROOMS -----------------------

buildroomfullscreendata:
  defb 0+180;,10
  defb s_stonebuildingwallleft
  defb 19+180;,10
  defb s_stonebuildingwallright
  defb 0+180;,10
  defb s_stoneroomtophoriz
  defb 0;,1 ; X, Y
  defb s_stoneroombottomhoriz
  defb 255 ; END OF LIST

buildbigroomtl:
  defb 0+180;,10
  defb s_stonebuildingwallleft
  defb 0;,1 ; X, Y
  defb s_stonecorridorhoriztop
  defb 0+0;,10
  defb s_stonebuildingwallcornertl
  defb 255 ; END OF LIST
buildbigroomtr:
  defb 19+180;,10
  defb s_stonebuildingwallright
  defb 0;,1 ; X, Y
  defb s_stonecorridorhoriztop
  defb 19+0;,10
  defb s_stonebuildingwallcornertr
  defb 255 ; END OF LIST
buildbigroombl:
  defb 0+180;,10
  defb s_stonebuildingwallleft
  defb 0+180;,10
  defb s_stonecorridorhorizbottom
  defb 0+180;,10
  defb s_stonebuildingwallcornerbl
  defb 255 ; END OF LIST
buildbigroombr:
  defb 19+180;,10
  defb s_stonebuildingwallright
  defb 0+180;,10
  defb s_stonecorridorhorizbottom
  defb 19+180;,10
  defb s_stonebuildingwallcornerbr
  defb 255 ; END OF LIST

buildgrandhallbottom:
  defb 0+180;,10
  defb s_stonecorridorhorizbottom
  defb 19+180;,10
  defb s_stonebuildingwallright
  defb 0+180;,10
  defb s_stonebuildingwallleft
  defb 0+180;,10
  defb s_stonebuildingwallcornerbl
  defb 19+180;,10
  defb s_stonebuildingwallcornerbr
  defb 255 ; END OF LIST
  
buildgrandhalltophalf:
  defb 0+0;,10
  defb s_stonecorridorhoriztop
  defb 19+180;,10
  defb s_stonebuildingwallright
  defb 0+180;,10
  defb s_stonebuildingwallleft
  defb 0+0;,10
  defb s_stonebuildingwallcornertl
  defb 19+0;,10
  defb s_stonebuildingwallcornertr
  defb 255 ; END OF LIST

buildroomwood:
  ld hl,buildroomfullscreendata
  call buildstaticroomdef
  ld hl,tilemap2+187
  ld (hl),252 ; INSERT DOOR OBJECT
  jp convertstonedungeontowood

buildroomwoodnodoor:
  ld hl,buildroomfullscreendata
  call buildstaticroomdef
  jp convertstonedungeontowood

buildroomlogcabindata:
  defb 11+80;,6
  defb s_cabinwalldiv
  defb 11+100
  defb s_cabinwalldivend
  defb 6+200;,11 ; START OUTSIDE OF SCREEN SO WE CAN PASTE OVER TOP OF WALL
  defb s_doorforest
  defb 13+200;,11 ; START OUTSIDE OF SCREEN SO WE CAN PASTE OVER TOP OF WALL
  defb s_windowforest
  defb 16+80
  defb s_bed
  defb 3+60
  defb s_basemententrance
  defb 255 ; END OF LIST

buildroomlogcabinunderwater:
  call setseapalette
buildroomlogcabin:
  call buildroomwood
  ld hl,buildroomlogcabindata
  call buildstaticroomdef
  ld a,s_table
  jp insspriterandpos_dolookup

buildouthouse2data:
  defb 9+80
  defb s_cavesystementrance
buildouthousedata:
  defb 9+140;,11 ; START OUTSIDE OF SCREEN SO WE CAN PASTE OVER TOP OF WALL
  defb s_doorthin
buildouthousedatanodoor:
  defb 8+80
  defb s_stonecorridordeadendtop
  defb 8+120
  defb s_stonecorridordeadendbottom
  defb 255

buildouthouse2:
  ld hl,buildouthouse2data
  jr doouthouse
buildouthouse:
  ld hl,buildouthousedata
  doouthouse:
  call buildstaticroomdef
  ld hl,tilemap2+129
  ld (hl),252 ; INSERT DOORWAY OBJECT
  inc l
  ld (hl),252 ; INSERT DOORWAY OBJECT
  jp convertstonedungeontowood

; --- GRAVE ---

buildgrave:
  ld hl,buildouthousedatanodoor
  call buildstaticroomdef
  ld hl,tilemap2+129
  ld (hl),252 ; INSERT DOORWAY OBJECT
  inc l
  ld (hl),252 ; INSERT DOORWAY OBJECT
  call convertstonedungeontocave
  jp checkinsertstaticobjectsinbuilding;buildwaterjumpback ; MAKE SURE WE CHECK IF WE NEED TO INSERT QUEST SPRITES

; --- JAIL ---

buildroomjaildata:
  defb 11+80
  defb s_cabinwalldiv
  defb 11+100
  defb s_cabinwalldivend
  defb 6+200            ; START OUTSIDE OF SCREEN SO WE CAN PASTE OVER TOP OF WALL
  defb s_doorforest
  defb 16+80
  defb s_oldmanjailor
  defb 255 ; END OF LIST

buildroomjail:
  call buildroomwood
  ld hl,buildroomjaildata
  call buildstaticroomdef
  jp tilefinished

; --- SHIP ---
buildroomshipoccupieddata:
  defb 13+120
  defb s_pegleg
buildroomshipdata:
  defb 11+200;,11 ; START OUTSIDE OF SCREEN SO WE CAN PASTE OVER TOP OF WALL
  defb s_doorforest
  defb 2+200;,11 ; START OUTSIDE OF SCREEN SO WE CAN PASTE OVER TOP OF WALL
  defb s_windowwestern
  defb 7+200;,11 ; START OUTSIDE OF SCREEN SO WE CAN PASTE OVER TOP OF WALL
  defb s_windowwestern
  defb 16+200;,11 ; START OUTSIDE OF SCREEN SO WE CAN PASTE OVER TOP OF WALL
  defb s_windowwestern
  defb 0+20;,1 ; X, Y
  defb s_shippwheelhousewallh ; SPRITE
  defb 3+80
  defb s_bed
  defb 7+80
  defb s_bed
  defb 11+80
  defb s_table
  defb 255 ; END OF LIST

; SUNKEN SHIP (LIKE PEGLEG'S)
buildroomshipsunken:
  call makeseapalette
  call buildroomwood
  ld hl,buildroomshipdata
  jr finishbuildroomship
buildroomship:
  call buildroomwood
  ld hl,buildroomshipoccupieddata
  finishbuildroomship:
  call buildstaticroomdef
  ld hl,tilemap2+192
  ld (hl),252 ; INSERT DOORWAY OBJECT
  jp convertstonedungeontowood

; UPTURNED SUNKEN SHIP (ACCESSABLE USING PICKAXE)
buildupturnedsunkenwreckdata:
  defb 8+20;,11 ; START OUTSIDE OF SCREEN SO WE CAN PASTE OVER TOP OF WALL
  defb s_doorforest
  ;defb 11+80
  ;defb s_bed
  defb 255

buildroomshipsunken2:
  call makeseapalette
  call buildroomstone
  ld hl,buildupturnedsunkenwreckdata
  call buildstaticroomdef
  ;ld hl,tilemap0+189
  ;ld (hl),94     ; DOOR WAY TILE
  ld hl,tilemap2+189 ; OBJECT MAP
  ld (hl),252    ; DOOR WAY OBJECT
  ld hl,tilemap0+189 ; OBJECT MAP
  ld (hl),100    ; DOOR WAY OBJECT
  jp convertstonedungeontowood

; --- STORE ---

buildroomstoredata:
  defb 11+200;,11 ; START OUTSIDE OF SCREEN SO WE CAN PASTE OVER TOP OF WALL
  defb s_doorforest
  defb 2+200;,11 ; START OUTSIDE OF SCREEN SO WE CAN PASTE OVER TOP OF WALL
  defb s_windowwestern
  defb 7+200;,11 ; START OUTSIDE OF SCREEN SO WE CAN PASTE OVER TOP OF WALL
  defb s_windowwestern
  defb 16+200;,11 ; START OUTSIDE OF SCREEN SO WE CAN PASTE OVER TOP OF WALL
  defb s_windowwestern
  defb 11+110
  defb s_shopkeeper
  ; TABLES
  defb 1+60
  defb s_bar
  defb 255 ; END OF LIST

buildroomstore:
  call buildroomwoodnodoor
  ld hl,buildroomstoredata
  call buildstaticroomdef
  ld hl,tilemap2+192
  ld (hl),252 ; INSERT DOOR OBJECT
  jp convertstonedungeontowood

; --- HOTEL ---

buildhotelbedroomdata:
  defb 8+200;,11 ; START OUTSIDE OF SCREEN SO WE CAN PASTE OVER TOP OF WALL
  defb s_doorforest
  defb 11+80
  defb s_bed
  defb 255

buildhotelbedroom:
  call buildroomstone
  ld hl,buildhotelbedroomdata
  call buildstaticroomdef
  ;ld hl,tilemap0+189
  ;ld (hl),94     ; DOOR WAY TILE
  ld hl,tilemap2+189 ; OBJECT MAP
  ld (hl),252    ; DOOR WAY OBJECT
  jp convertstonedungeontowood

buildroomhoteldata:
  defb 4+200;,11 ; START OUTSIDE OF SCREEN SO WE CAN PASTE OVER TOP OF WALL
  defb s_windowwestern
  defb 8+200;,11 ; START OUTSIDE OF SCREEN SO WE CAN PASTE OVER TOP OF WALL
  defb s_saloondoorinside
  defb 14+200;,11 ; START OUTSIDE OF SCREEN SO WE CAN PASTE OVER TOP OF WALL
  defb s_windowwestern
  
  ; STAIRS
  defb 4+20
  defb s_stairs3
  defb 4+60
  defb s_stairs
  defb 1+60
  defb s_stairs2

  ; BEDROOMS
  defb 14+20
  defb s_doorforest
  defb 3+20
  defb s_doorforest
  defb 255 ; END OF LIST

buildroomhotelroomsdata:
  defb 10+200;,11 ; START OUTSIDE OF SCREEN SO WE CAN PASTE OVER TOP OF WALL
  defb s_windowwestern
  defb 255 ; END OF LIST

buildroomhotel:
  call buildroomwoodnodoor
  ld hl,buildroomhoteldata
  call buildstaticroomdef
  ld hl,tilemap2+189
  ld (hl),252 ; INSERT DOOR OBJECT
  ld hl,tilemap2+15
  ld (hl),212 ; INSERT DOOR OBJECT
  ld hl,tilemap2+4
  ld (hl),212 ; INSERT DOOR OBJECT
  call makeeastentranceshort
  call makewestentranceshort
  jp convertstonedungeontowood

buildroomhotelleft:
  call buildroomwoodnodoor
  ;call buildabbeytables
  call makewestentranceshort
  ld hl,saloontablesdata
  call buildstaticroomdef 
  ld hl,buildroomhotelroomsdata
  ;call buildstaticroomdef 
  call populatesaloon
  jp convertstonedungeontowood

buildroomhotelright:
  call buildroomwoodnodoor
  call buildabbeytables
  call makeeastentranceshort
  ld hl,buildroomhotelroomsdata
  call buildstaticroomdef
  jp convertstonedungeontowood

;buildroomhoteltop
;  call buildroomwoodnodoor
;  call makeeastentranceshort
;  call makesouthentrance
;  jp convertstonedungeontowood

; --- SALOON ---

buildroomsaloondata:
  defb 6+200;,11 ; START OUTSIDE OF SCREEN SO WE CAN PASTE OVER TOP OF WALL
  defb s_saloondoorinside
  defb 2+200;,11 ; START OUTSIDE OF SCREEN SO WE CAN PASTE OVER TOP OF WALL
  defb s_windowwestern
  defb 11+200;,11 ; START OUTSIDE OF SCREEN SO WE CAN PASTE OVER TOP OF WALL
  defb s_windowwestern
  defb 16+200;,11 ; START OUTSIDE OF SCREEN SO WE CAN PASTE OVER TOP OF WALL
  defb s_windowwestern
  saloontablesdata:
  ; TABLES
  defb 2+60
  defb s_bar
  defb 3+140
  defb s_table
  defb 13+140
  defb s_table
  defb 10+20
  defb s_barman
  defb 255 ; END OF LIST

buildroomsaloon:
  call buildroomwood
  ld hl,buildroomsaloondata
  populatesaloon:
  call buildstaticroomdef
  ld a,s_oldmansaloongame
  jp insspriterandpos_dolookup

; --- BANK ---

buildroombankdata:
  defb 14+180;,10
  defb s_stonebuildingwallright
  defb 15+180;,10
  defb s_stonebuildingwallleft
  defb 6+200;,11 ; START OUTSIDE OF SCREEN SO WE CAN PASTE OVER TOP OF WALL
  defb s_doorforest
  defb 2+200;,11 ; START OUTSIDE OF SCREEN SO WE CAN PASTE OVER TOP OF WALL
  defb s_windowwestern
  defb 11+200;,11 ; START OUTSIDE OF SCREEN SO WE CAN PASTE OVER TOP OF WALL
  defb s_windowwestern
  defb 16+200;,11 ; START OUTSIDE OF SCREEN SO WE CAN PASTE OVER TOP OF WALL
  defb s_windowwestern
  ; TABLES
  defb 14+0
  defb s_stonewalldivisiontop
  defb 14+180
  defb s_stonewalldivisionbottom
  defb 9+120 ; X 9,10
  defb s_townbanker
  defb 5+80
  defb s_table
  defb 255 ; END OF LIST

buildroombankfilldata:
  defb 36,8,3,moneybag,250 ; MONEY BAG PICKABLE OBJECT
  defb 54,7,1,16,8         ; LEFT WALL
  defb 55,7,1,216,8        ; RIGHT WALL
  defb 255

buildroombank:
  call buildroomwood
  ld hl,buildroombankdata
  call buildstaticroomdef
  call convertstonedungeontowood
  ; FILL CAVITY WITH GOLD
  ld hl,buildroombankfilldata
  jp buildfill
  
buildroomlogcabinwesterndata:
  defb 11+80
  defb s_cabinwalldiv
  defb 11+100
  defb s_cabinwalldivend
  defb 6+200            ; START OUTSIDE OF SCREEN SO WE CAN PASTE OVER TOP OF WALL
  defb s_doorforest
  defb 13+200           ; START OUTSIDE OF SCREEN SO WE CAN PASTE OVER TOP OF WALL
  defb s_windowwestern
  defb 16+80
  defb s_bed
  defb 4+120
  defb s_table
  defb 255 ; END OF LIST

buildroomlogcabinwestern:
  call buildroomwood
  ld hl,buildroomlogcabinwesterndata
  jp buildstaticroomdef

; --------------------------------------------
; ------------ CAVE --------------------------
; --------------------------------------------

; CONVERT A STONE DUNGEON TO A CAVE DUNGEON
; TO SAVE MEMORY, ALL WE DO IS CONVERT TILE IMAGES ON SCREEN TO THEIR CAVE EQUIVALENT
; THIS SAVES US HAVING TO MAKE TWO SETS OF SPRITES/ROOMS FOR SIMILAR SHAPED DUNGEONS

;buildroomcave
;  jp buildnorthcaveexit
;  jp convertstonedungeontocave

woodtiletable:
  defb 16   ; g_woodenwallleft
  defb 16   ; g_woodenwallleft
  defb 216  ; g_woodenwallleft
  defb 212  ; g_woodencornerbl              ; 12
  defb 12   ; g_woodencornerbl              ; 12
  defb 23   ; g_woodencornertopright        ; 23
  defb 223  ; g_woodencornertopright        ; 23
  defb 85   ; g_woodenboards                ; 114

cavetiletable:
  defb 213  ; g_wigwamwallleft
  defb 213  ; g_wigwamwallleft
  defb 13   ; g_wigwamwallleft
  defb 15   ; g_wigwamcornerright  
  defb 215  ; g_wigwamcornerright
  defb 36   ; g_wigwaminsidecorner
  defb 236  ; g_wigwaminsidecorner
  defb 54   ; g_wigwamtop

stonetiletable:
  defb 40    ; g_insidestonebuildrightwall
  defb 40    ; g_insidestonebuildrightwall
  defb 240   ; g_insidestonebuildrightwall
  defb 45    ; g_insidestonebuildbottomright
  defb 245   ; g_insidestonebuildbottomright
  defb 46    ; g_insidestonebuildingcorner
  defb 246   ; g_insidestonebuildingcorner
  defb 136   ; g_insidestonebuildtopwall

;builddungeonleftdeadendwood
;  call builddungeonleftdeadend
convertstonedungeontowood:
  ld bc,woodtiletable
  jr convertstonedungeon


builddungeonleftdeadendcave:
  call builddungeonleftdeadend
convertstonedungeontocave:
  ld bc,cavetiletable
  convertstonedungeon:
  ld (switchtiletable-2),bc
convertstonedungeontocave2:
  ld de,tilemap0
  ld b,200 ; 200 TILES ON SCREEN TO CHECK
  converttocaveloop:
    push bc

    ld a,(de)
    or a     ; SKIP IF TILE IS JUST EMPTY
    jr z,movenextstonetile

    ld bc,8 ; NUM SPRITES TO CHECK IN LIST
    ld hl,stonetiletable+7
    cpdr                            ; COMPARE BLOCK UNTIL WE FIND MATCH
    ld a,c
    or a
    jr z,movenextstonetile

    ; MODIFY STONE TILE TO CAVE TILE EQUIVALENT
    ld hl,cavetiletable :switchtiletable
    add hl,bc
    ld a,(hl)
    ld (de),a   

    movenextstonetile:
    inc e
    pop bc  
  djnz converttocaveloop
ret
  
; --------------------------------------------
; ------------ DUNGEON -----------------------
; --------------------------------------------

buildcavewaterfall:
  call setseapalette
  call buildroomstone
  ld hl,tilemap0+189
  ld (hl),94     ; DOOR WAY TILE
  ld h,tilemap2h ; OBJECT MAP
  ld (hl),239    ; DOOR WAY OBJECT
  jp convertstonedungeontocave
  ;ld bc,&246E ; X = 28, Y=120
  ;jp setnewlocation

; DUNGEON MAP GRID
static_map_dungeon:
  ; SELF MODIFYING DUNGEON MAP

  ; IF THE PLAYER ENTERS A BIG BUILDING LIKE A HOTEL, MINE, ETC
  ; THESE GET FILLED IN SO THE PLAYER CAN ENTER A PSEUDO RANDOM GENERATED BUILDING
  ; AND SCROLL FROM SCREEN TO SCREEN WITHOUT HAVING IT BUILT STATICALLY FOR EACH TOWN

  defb 100,100:selfmoddung1 ; X / Y SCREEN LOCATION
  defw 0:selfmoddung1func1  ; FUNCTION TO BUILD ROOM
  defb 100,100:selfmoddung2
  defw 0:selfmoddung1func2
  defb 100,100:selfmoddung3
  defw 0:selfmoddung1func3
  defb 100,100:selfmoddung4
  defw 0:selfmoddung1func4
  defb 100,100:selfmoddung5
  defw 0:selfmoddung1func5
  defb 100,100:selfmoddung6
  defw 0:selfmoddung1func6
  defb 100,100:selfmoddung7
  defw 0:selfmoddung1func7
  defb 100,100:selfmoddung8
  defw 0:selfmoddung1func8
  defb 100,100:selfmoddung9
  defw 0:selfmoddung1func9

  ; STATICALLY BUILT DUNGEONS

  ; HOME MINE
  defb 2, 0
  defw buildcavenorth
  defb 2, 1                             ; X / Y SCREEN LOCATION
  defw buildcavecrossroads;builddungeonchamberwestcave ; FUNCTION TO BUILD ROOM
  defb 1, 1
  defw buildcavewest
  defb 3, 1
  defw buildcavehoriz
  defb 4, 1
  defw buildcavewestsouth
  defb 4, 2
  defw buildcavevert
  defb 4, 3
  defw buildcaveeastnorth
  defb 5, 3
  defw buildcavehoriz
  defb 6, 3
  defw buildcavewestsouth
  defb 6, 4
  defw buildcavevert
  defb 6, 5
  defw buildcavevert
  defb 6, 6                             ; X / Y SCREEN LOCATION
  defw buildcavecrossroads
  defb 5, 6
  defw buildcavewest
  defb 7, 6
  defw buildcaveeast

  ; WATERFALL
  defb 9,  26
  defw buildcavewaterfall ; FUNCTION TO BUILD ROOM
  defb 9,  76
  defw buildcavewaterfall ; FUNCTION TO BUILD ROOM
  defb 49, 16
  defw buildcavewaterfall ; FUNCTION TO BUILD ROOM

  ; JUNGLE CAVE SYSTEM
  ;defb 36, 56                       ; X / Y SCREEN LOCATION
  ;defw buildcavevert
  ;defb 36, 57                       ; X / Y SCREEN LOCATION
  ;defw buildcavecrossroads          ; FUNCTION TO BUILD ROOM
  ;defb 35, 57                       ; X / Y SCREEN LOCATION
  ;defw buildcavewest                ; FUNCTION TO BUILD ROOM
  ;defb 36, 55                       ; X / Y SCREEN LOCATION
  ;defw buildcavenorthenemies        ; FUNCTION TO BUILD ROOM
  ;defb 37, 57                       ; X / Y SCREEN LOCATION
  ;defw builddungeoneastnorthcave    ; FUNCTION TO BUILD ROOM
  ;defb 37, 56                       ; X / Y SCREEN LOCATION
  ;defw buildcavenorth               ; FUNCTION TO BUILD ROOM

  ; BUSH SECRET ENTRANCE DUNGEON - EXITS X44 Y22
  defb 34, 25                       ; X / Y SCREEN LOCATION
  defw buildcavewestdungeonexit     ; FUNCTION TO BUILD ROOM
  defb 35, 25 
  defw buildcavehoriz
  defb 36, 25
  defw buildcavehoriz
  defb 37, 25                       ; X / Y SCREEN LOCATION
  defw buildcavewestnorth           ; FUNCTION TO BUILD ROOM
  defb 37, 24                       ; X / Y SCREEN LOCATION
  defw buildcavevert                ; FUNCTION TO BUILD ROOM
  defb 37, 23                       ; X / Y SCREEN LOCATION
  defw buildcaveeastsouth           ; FUNCTION TO BUILD ROOM
  defb 38, 23 
  defw buildcavehoriz
  defb 39, 23 
  defw buildcavehoriz
  defb 40, 23 
  defw buildcavehoriz
  defb 41, 23                       ; X / Y SCREEN LOCATION
  defw buildcavewestnorth           ; FUNCTION TO BUILD ROOM
  defb 41, 22                       ; X / Y SCREEN LOCATION
  defw buildcaveeastsouth           ; FUNCTION TO BUILD ROOM
  defb 42, 22 
  defw buildcavehoriz
  defb 43, 22 
  defw buildcavehoriz
  defb 44, 22                       ; X / Y SCREEN LOCATION
  defw buildcaveeastdungeonexit     ; FUNCTION TO BUILD ROOM

  ; UNDERWATER DUNGEON
  defb 15, 54                       ; X / Y SCREEN LOCATION
  defw builddungeonwest             ; FUNCTION TO BUILD ROOM
  defb 16, 54                       ; X / Y SCREEN LOCATION
  defw builddungeonrightdeadend     ; FUNCTION TO BUILD ROOM

  ; CASTLE DUNGEON - WESTERN ZONE
  ;defb 18, 35                       ; X / Y SCREEN LOCATION
  ;defw builddungeonrightdeadend     ; FUNCTION TO BUILD ROOM
  ;defb 17, 35                       ; X / Y SCREEN LOCATION
  ;defw buildgrandhallbot;builddungeonwestnorth        ; FUNCTION TO BUILD ROOM
  ;defb 17, 34                       ; X / Y SCREEN LOCATION
  ;defw buildgrandhalltop;builddungeonroomnorth        ; FUNCTION TO BUILD ROOM - CELL IN WHICH PRINCESS IS LOCKED

  ; CASTLE DUNGEON - KINGS CAPE
  defb 92, 26                       ; X / Y SCREEN LOCATION
  defw builddungeonroomnorthexit;builddungeoncrossroad        ; FUNCTION TO BUILD ROOM
  ;defb 91, 26                       ; X / Y SCREEN LOCATION
  ;defw builddungeonwest             ; FUNCTION TO BUILD ROOM
  ;defb 93, 26                       ; X / Y SCREEN LOCATION
  ;defw builddungeonrightdeadend     ; FUNCTION TO BUILD ROOM
  ;defb 92, 27                       ; X / Y SCREEN LOCATION
  ;defw builddungeonsouth            ; FUNCTION TO BUILD ROOM
  ;defb 92, 25                       ; X / Y SCREEN LOCATION
  ;defw builddungeonnorth            ; FUNCTION TO BUILD ROOM

  ; CAVES 
  defb 18, 46                       ; X / Y SCREEN LOCATION
  defw buildcavehoriz               ; FUNCTION TO BUILD ROOM
  defb 17, 46                       ; X / Y SCREEN LOCATION
  defw buildcavewest                ; FUNCTION TO BUILD ROOM
  defb 19, 46                       ; X / Y SCREEN LOCATION
  defw buildcaverightdeadend        ; FUNCTION TO BUILD ROOM

  ; CRYPT
  ; UNDERWATER DUNGEON
  ;defb 7, 58                       ; X / Y SCREEN LOCATION
  ;defw builddungeonchamberwest     ; FUNCTION TO BUILD ROOM
  defb 8, 58                        ; X / Y SCREEN LOCATION
  defw buildroomcrypt;builddungeonrightdeadend ; FUNCTION TO BUILD ROOM

  ;defb 18, 47                      ; X / Y SCREEN LOCATION
  ;defw builddungeonchambersouthcave ; FUNCTION TO BUILD ROOM
  ;defb 18, 45                      ; X / Y SCREEN LOCATION
  ;defw builddungeonchambernorthcave ; FUNCTION TO BUILD ROOM
  defb 255  ; END OF LIST

; CODE TO SCAN DUNGEON MAP AND DECIDE WHICH ROOM TO BUILD
buildroomdungeon:
  ; CHECK OUR COORDINATES, AND BUILD APPROPRIATE ROOM IF WE FIND A MATCH
  ld hl,static_map_dungeon
  ld bc,(tilemap_cur) ; LOAD CURRENT TILEMAP LOCATION INTO B/C
  staticmapdungeonloop:
    ld a,(hl)
    inc a;cp 255
    ret z  ; END OF LIST

    ; CHECK IF CURRENT MAP IS IN LIST
    ld a,(hl)
    cp c ; CHECK X
    jr nz,findnextstaticmapdungeon
    inc hl
    ld a,(hl)
    cp b ; CHECK Y
    jr nz,findnextstaticmapdungeon2
    inc hl

    ; GET ADDRESS OF FUNCTION TO RUN
    ld a,(hl)
    inc hl
    ld h,(hl)
    ld l,a
    jp (hl)

    findnextstaticmapdungeon:
    inc hl
    findnextstaticmapdungeon2:
    inc hl
    inc hl
    inc hl
    jr staticmapdungeonloop

builddungeonleftdeadenddata:
  defb 15+80 
  defb s_stonecorridorlefttop
  defb 15+120
  defb s_stonecorridorleftbottom
  defb 255    ; END OF LIST

builddungeonleftdeadend:
  ld hl,builddungeonleftdeadenddata
  jp buildstaticroomdef
  
builddungeonrightdeadenddata:
  defb 0+60  
  defb s_stonecorridorhoriztopshort
  defb 0+120 
  defb s_stonecorridorhorizbottomshort
  defb 4+101
  defb s_dungeonexit
  defb 4+80  
  defb s_stonecorridorrighttop
  defb 4+120 
  defb s_stonecorridorrightbottom
  defb 255 ; END OF LIST

builddungeonrightdeadend:
  ld hl,builddungeonrightdeadenddata
  jp buildstaticroomdef
buildcaverightdeadend:
  call builddungeonrightdeadend
  jp convertstonedungeontocave

builddungeonvertdata:
  defb 8+180 
  defb s_stonecorridorvert
  defb 8+120 
  defb s_stonecorridorvert
  defb 8+60 
  defb s_stonecorridorvert
  defb 8+40 
  defb s_stonecorridorvert
  defb 255 ; END OF LIST

buildcavevert:
  ld hl,builddungeonvertdata
  call buildstaticroomdef 
  jp convertstonedungeontocave
  
builddungeonhorizdata:
  defb 0+60  
  defb s_stonecorridorhoriztop
  defb 0+120 
  defb s_stonecorridorhorizbottom
  defb 255   ; END OF LIST

builddungeonhoriz:
  ld hl,builddungeonhorizdata
  jp buildstaticroomdef
buildcavehoriz:
  call builddungeonhoriz
  jp convertstonedungeontocave

builddungeoncrossroaddata:
  defb 8+60 
  defb s_stonecorridortop
  defb 8+180 
  defb s_stonecorridorbottom
  defb 255   ; END OF LIST

builddungeoncrossroad:
  ld hl,builddungeonhorizdata
  call buildstaticroomdef 
  ld hl,builddungeoncrossroaddata
  jp buildstaticroomdef
builddungeoncrossroadcave:
  call builddungeoncrossroad
  jp convertstonedungeontocave

builddungeonwestnorth:
  call builddungeonwest
  makenorthentrancedoor:
  ld hl,makenorthentrancedoordata
  jp buildstaticroomdef

buildcavewestsouth:
  call builddungeoneast
  docavesouthentrance:
  call makesouthentrance
  jp convertstonedungeontocave

buildcaveeastsouth:
  call builddungeonwest
  jr docavesouthentrance

buildcaveeastnorth:
  call builddungeonwest 
  docavenorthentrance:
  call makenorthentrance
  jp convertstonedungeontocave

buildcavewestnorth:
  call builddungeoneast
  jr docavenorthentrance

builddungeoneastnorth:
  call builddungeoneast
  jp makenorthentrance


;buildironorerocksdata
;  defb 5                 ; MAX RAND OF SPRITE TO INSERT
;  defb s_ironmountain
;  defb 255 ; END OF LIST

builddungeoneastnorthcave:
  call builddungeoneastnorth
  call convertstonedungeontocave
  ; MAKE IRON ORE MOUND
; ld hl,buildironorerocksdata
; call domyfoliage 
  insertrandomironmountains:
  ld a,s_ironmountain
  ld b,5
  jp insertspriterandtimes_dolookup
;  jp convertstonedungeontocave

builddungeonsouthdata:
  defb 8+00 
  defb s_stonecorridorentrancetop
  defb 255 ; END OF LIST

makenorthentrancedoordata:
  defb 9+0 
  defb s_dungeondoor
  defb 255 ; END OF LIST

builddungeonsouth:
  call buildroomstone
  makenorthentrance:
  ld hl,builddungeonsouthdata
  jp buildstaticroomdef

builddungeonnorthdata:
  defb 8+180 
  defb s_stonecorridorentrancebottom
  defb 255 ; END OF LIST

builddungeonenemiesdata:
  defb 5+60
  defb s_turret
  defb 14+80
  defb s_turret
  defb 5+100
  defb s_turret
  defb 14+120
  defb s_turret
  defb 5+140
  defb s_turret
  defb 14+160
  defb s_turret

  defb 7+60
  defb s_turrettarget
  defb 8+80
  defb s_turrettarget
  defb 7+100
  defb s_turrettarget
  defb 8+120
  defb s_turrettarget
  defb 7+140
  defb s_turrettarget
  defb 8+160
  defb s_turrettarget
  defb 255 ; END OF LIST

buildcavenorthenemies:
  call builddungeonnorth
  ld hl,builddungeonenemiesdata
  jp convertstonedungeontocave

builddungeonnorth:
  call buildroomstone
  makesouthentrance:
  ld hl,builddungeonnorthdata
  jp buildstaticroomdef

buildcavenorth:
  call builddungeonnorth
  jp convertstonedungeontocave

builddungeonroomnorth:
  call buildroomstone
  jp makesouthentrance

builddungeonroomnorthexit:
  call builddungeonroomnorth
  jr buildroomsouthexit

buildroomcave:
  call buildcavenorth
  ; MAKE EXIT DOOR IN CAVE
  buildroomsouthexit:
  ld hl,tilemap2+189
  ld (hl),252
  ld hl,tilemap2+190
  ld (hl),252
  ret

buildcavecrossroads:
  call builddungeoncrossroadcave
  ; MAKE EXIT DOOR IN CAVE
  jr buildroomsouthexit

builddungeoneastdata:
  defb 0+80 
  defb s_stonecorridorentrancelefttop
  defb 0+100 
  defb s_stonecorridorclearentrancehoriz
  defb 0+120 
  defb s_stonecorridorentranceleftbottom
  defb 255 ; END OF LIST

builddungeoneast:
  call buildroomstone
  makeeastentrance:
  ld hl,builddungeoneastdata
  jp buildstaticroomdef

builddungeoneastshortdata:
  defb 0+80 
  defb s_stonecorridorentrancelefttopshort
  defb 0+100 
  defb s_dirt
  defb 0+120 
  defb s_stonecorridorentranceleftbottomshort
  defb 255 ; END OF LIST

builddungeoneastshort:
  call buildroomstone
  makeeastentranceshort:
  ld hl,builddungeoneastshortdata
  jp buildstaticroomdef

builddungeonwestshortdata:
  defb 19+80 
  defb s_stonecorridorentrancerighttopshort
  defb 19+100 
  defb s_dirt
  defb 19+120 
  defb s_stonecorridorentrancerightbottomshort
  defb 255 ; END OF LIST

builddungeonwestshort:
  call buildroomstone
  makewestentranceshort:
  ld hl,builddungeonwestshortdata
  jp buildstaticroomdef

builddungeonwestdata:
  defb 15+60 
  defb s_stonecorridorentrancerighttop
  defb 15+100 
  defb s_stonecorridorclearentrancehoriz
  defb 15+120 
  defb s_stonecorridorentrancerightbottom
  defb 255 ; END OF LIST

builddungeonwest:
  call buildroomstone
  makewestentrance:
  ld hl,builddungeonwestdata
  jp buildstaticroomdef

buildcavewest:
  call builddungeonwest
  jp convertstonedungeontocave

buildroombuildcaveeastdungeonexitdata:
  defb 8+100
  defb s_dungeonexit
  defb 255 ; END OF LIST

buildcavewestdungeonexit:
  call buildcavewest
  ld hl,buildroombuildcaveeastdungeonexitdata
  jp buildstaticroomdef

buildcaveeastdungeonexit:
  call buildcaveeast
  ld hl,buildroombuildcaveeastdungeonexitdata
  jp buildstaticroomdef

buildcaveeast:
  call builddungeoneast
  jp convertstonedungeontocave

; ------------ BASEMENTS ---------------------------
; LIKE DUNGEONS, BUT RANDOMLY GENERATED SINGLE ROOMS

buildroomcryptdata:
  defb 5+100
  defb s_dungeonexit
  defb 255 ; END OF LIST

buildroomcrypt:
  call buildroomstone
  ld hl,buildroomcryptdata
  jp buildstaticroomdef

buildroombasementdata:
  defb 6+40
  defb s_dungeonexit
  defb 255 ; END OF LIST

buildroombasement:
  call buildroomstone
  ld hl,buildroombasementdata
  jp buildstaticroomdef
  
; STONE ROOMS

buildroomstonedata:
  defb 4+180;,10
  defb s_stonebuildingwallleft
  defb 15+180
  defb s_stonebuildingwallright
  defb 4+0;,1 ; X, Y
  defb s_stonebuildingwallh ; SPRITE
  defb 4+180;,10
  defb s_stonebuildingwallhbottom
  defb 255 ; END OF LIST


; A = START TILE
; B = FILL HEIGHT IN TILES
; C = FILL WIDTH IN TILES
; D = TILE ID GRAPHIC
; E = OBJECT TILE ID
buildfillstoneroomdata:
  defb 0,13,20,0,1   ; MAKE ALL SCREEN TILES FILLED
  defb 25,8,10,0,0   ; CLEAR CENTRAL ROOM TILES
  defb 255

buildroomstone:
  ; FILL BLANK AREAS OF ROOM TO STOP TABLES APPEARING IN THEM
  ld hl,buildfillstoneroomdata
  call buildfill
  ld hl,buildroomstonedata
  jp buildstaticroomdef

buildroomstonebuildingdata:
  defb 8+200;,11 ; START OUTSIDE OF SCREEN SO WE CAN PASTE OVER TOP OF WALL
  defb s_doorforest
  defb 255 ; END OF LIST

buildroomstonebuilding:
  call buildroomstonetorches
  call buildroomstonebuildingdoor
  ld a,s_table
  jp insspriterandpos_dolookup

buildroomstonebuildingdoor:
  ld hl,buildroomstonebuildingdata
  call buildstaticroomdef
  ; INSERT DOOR OBJECT
  ld hl,tilemap2+189
  ld (hl),252
  ret

; --- CASTLE ----------------------------------

; INSERT CURRENT PLAYER X LOCATION IN DUNGEON MAP


; 7       8      9
; 4       5      6
; 1       2      3
; 0 - ENTRANCE - 0
setstandarddynamicdungeonlayout:
  ld c,(ix+4)
  ld b,(ix+5)
  dec c
  ld (selfmoddung1-2),bc
  inc c
  ld (selfmoddung2-2),bc
  inc c
  ld (selfmoddung3-2),bc
  dec c
  dec c
  dec b
  ld (selfmoddung4-2),bc
  inc c
  ld (selfmoddung5-2),bc
  inc c
  ld (selfmoddung6-2),bc
  dec c
  dec c
  dec b
  ld (selfmoddung7-2),bc
  inc c
  ld (selfmoddung8-2),bc
  inc c
  ld (selfmoddung9-2),bc
ret

insertcastledungeonmaps:
  ; INSERT CURRENT PLAYER X LOCATION IN DUNGEON MAP
  call setstandarddynamicdungeonlayout

  ; INSERT ROOM BUILDING FUNCTIONS IN MAP
  ld bc,builddungeonwest;buildroomhotel
  ld (selfmoddung1func1-2),bc
  ld (selfmoddung1func4-2),bc
  ld bc,buildgrandhallbot
  ld (selfmoddung1func2-2),bc
  ld bc,builddungeoneast
  ld (selfmoddung1func3-2),bc
  ld (selfmoddung1func6-2),bc
  ld bc,buildgrandhalltop;buildroomhotel
  ld (selfmoddung1func5-2),bc
ret

; --- CAVE SYSTEM -----------------------------

insertcavesystemdungeonmaps:
  ; INSERT CURRENT PLAYER X LOCATION IN DUNGEON MAP
  call setstandarddynamicdungeonlayout

  ; JUNGLE CAVE SYSTEM
  ld bc,buildcavewest
  ld (selfmoddung1func1-2),bc
  ld bc,buildcavecrossroads          ; FUNCTION TO BUILD ROOM
  ld (selfmoddung1func2-2),bc
  ld bc,builddungeoneastnorthcave    ; FUNCTION TO BUILD ROOM
  ld (selfmoddung1func3-2),bc
  ld bc,buildcavenorth            ;builddungeoneastnorthcave;buildcavenorthenemies        ; FUNCTION TO BUILD ROOM
  ld (selfmoddung1func5-2),bc
  ld bc,buildcavevert            ;buildcavenorth;builddungeoneastnorthcave    ; FUNCTION TO BUILD ROOM
  ld (selfmoddung1func6-2),bc
  ld bc,buildcavenorthenemies    ;buildcavenorth               ; FUNCTION TO BUILD ROOM
  ld (selfmoddung1func9-2),bc
ret

; --- HOTEL -----------------------------------

; INSERT ROOM INTO STATIC DUNGEON MAP
inserthoteldungeonmaps:
  ; INSERT CURRENT PLAYER X LOCATION IN DUNGEON MAP
  call setstandarddynamicdungeonlayout

  ; INSERT ROOM BUILDING FUNCTIONS IN MAP
  ld bc,buildroomhotelleft
  ld (selfmoddung1func1-2),bc
  ld bc,buildroomhotel
  ld (selfmoddung1func2-2),bc
  ld bc,buildroomhotelright
  ld (selfmoddung1func3-2),bc
ret

insertabbeydungeonmaps:
  ; INSERT CURRENT PLAYER X LOCATION IN DUNGEON MAP
  ld c,(ix+4)
  ld b,(ix+5)
  ld (selfmoddung1-2),bc
  inc c
  ld (selfmoddung2-2),bc
  inc c
  ld (selfmoddung3-2),bc
  dec b
  ld (selfmoddung4-2),bc
  dec c
  ld (selfmoddung5-2),bc

  ; INSERT ROOM BUILDING FUNCTIONS IN MAP
  ld bc,buildroomstoneabbeyentrance
  ld (selfmoddung1func1-2),bc
  ld bc,buildabbeychamberbl
  ld (selfmoddung1func2-2),bc
  ld bc,buildabbeychamberbr
  ld (selfmoddung1func3-2),bc
  ld bc,buildabbeychambertr
  ld (selfmoddung1func4-2),bc
  ld bc,buildabbeychambertl
  ld (selfmoddung1func5-2),bc
ret

; --- ABBEY -----------------------------------

abbeytables:
  defb 4+120
  defb s_table
  defb 12+120
  defb s_table
  defb 255 ; END OF LIST

; MAKE ENTRANCE TO GRAND HALL
abbeybigroomentrancedata:
  defb 0+80
  defb s_stonecorridorentrancelefttopshort
  defb 0+120
  defb s_stonecorridorentranceleftbottomshort
  defb 5+200;,11 ; START OUTSIDE OF SCREEN SO WE CAN PASTE OVER TOP OF WALL
  defb s_windowforest
  defb 14+200;,11 ; START OUTSIDE OF SCREEN SO WE CAN PASTE OVER TOP OF WALL
  defb s_windowforest
  defb 255 ; END OF LIST

abbeybigroomtopend:
  defb 4+200;,11 ; START OUTSIDE OF SCREEN SO WE CAN PASTE OVER TOP OF WALL
  defb s_windowforest
  defb 13+200;,11 ; START OUTSIDE OF SCREEN SO WE CAN PASTE OVER TOP OF WALL
  defb s_windowforest
  defb 255 ; END OF LIST

buildgrandhallbot:
  ld hl,buildgrandhallbottom
  call buildstaticroomdef
  call buildroomstonebuildingdoor;makesouthentrance
  ;jp buildroomstonebuildingdoor
  jr buildgrandhallentrances

buildgrandhalltop:
  ld hl,buildgrandhalltophalf
  call buildstaticroomdef
  buildgrandhallentrances:
  call makeeastentranceshort
  jp makewestentranceshort

buildabbeychamberbl:
  ld hl,buildbigroombl
  call buildstaticroomdef
  ld hl,abbeybigroomentrancedata
  call buildstaticroomdef
  buildabbeytables:
  ld hl,abbeytables
  jp buildstaticroomdef
buildabbeychamberbr:
  ld hl,buildbigroombr
  call buildstaticroomdef
  ld hl,abbeybigroomtopend
  call buildstaticroomdef
  jr buildabbeytables
buildabbeychambertl:
  ld hl,buildbigroomtl
  call buildstaticroomdef
  jr buildabbeytables
buildabbeychambertr:
  ld hl,buildbigroomtr
  call buildstaticroomdef
  jr buildabbeytables 

buildroomstoneabbeyentrance:
  call builddungeonwest
  ; INSERT DOOR OBJECT
  ld hl,tilemap2+189
  ld (hl),252
  ld hl,buildroomstonebuildingdata
  jp buildstaticroomdef

buildroomstonetorches:
  call buildroomstone
  ld b,anim_torchright   ; LOWER SPRITE ID IN ANIM TABLE
  ld c,95                ; TILE NUMBER
  ld d,0                 ; FLIPPED
  call activatetileanim 
  ld b,anim_torchright   ; LOWER SPRITE ID IN ANIM TABLE
  ld c,84                ; TILE NUMBER
  ld d,1                 ; FLIPPED
  jp activatetileanim 

buildroomchurchdata:
  defb 9+40
  defb s_minister
  defb 6+120
  defb s_pew
  defb 6+80
  defb s_pew
  defb 11+120
  defb s_pew
  defb 11+80
  defb s_pew
  defb 7+100
  defb s_settlermanchurch
  defb 255 ; END OF LIST

buildroomchurch:
  call buildroomstonebuilding
  ld hl,buildroomchurchdata
  jp buildstaticroomdef

;buildroomchurchwedding
;  call buildroomchurch
;  ; INSERT WIFE AT FRONT OF CHURCH
;  ld hl,tilemap0+10+60
;  ld a,(wifelocation+5)
;  ld (hl),a
;  ld h,tilemap2h    ;call movetotilemap2
;  ld (hl),220
;  ret

; ------------ OTHER BUILDINGS -----------------------

;buildroomwigwamdata:
;  defb 0+20;,2 ; X, Y
;  defb s_wigwaminsidetoprow ; SPRITE
;  defb 0+160;,9 ; X, Y
;  defb s_wigwaminside ; SPRITE
;  defb 0+180;,2 ; X, Y
;  defb s_wigwaminsidebottomrow ; SPRITE
;  defb 255 ; END OF LIST

buildroomwigwam:
  call buildroomstone
  call convertstonedungeontocave
  ld hl,tilemap0+189
  ld (hl),94     ; DOOR WAY TILE
  ld h,tilemap2h ; OBJECT MAP
  ld (hl),252    ; DOOR WAY OBJECT

  ;call fillobjectmap
  ;ld hl,dograssdata

  ;call loadgrasstable
  ;ld hl,buildroomwigwamdata
  ; MAKE GROUND PASSABLE
  ;call buildstaticroomdef
  ; STOP COCHICE'S HEADDRESS GETTING FLIPPED IN WALL
  ld a,25     ; TILENUM
  ld bc,&010A ; HEIGHT / WIDTH
  ld d,254    ; BLOCK SPRITE FROM STANDING ALONG TOP WALl
  call fillobjectmap

  ld b,anim_fire1 ; LOWER SPRITE ID IN ANIM TABLE
  ld c,90         ; TILE NUMBER
  jp activatetileanim 

buildminedata:
  defb 9+80               ; X, Y
  defb s_minetunneltop    ; SPRITE
  defb 9+180
  defb s_minetunnelbottom
  defb 255                ; END OF LIST

buildroommine:
  ld hl,buildminedata
  jp buildstaticroomdef

buildroommine2:
  call buildroommine
  ld hl,tilemap2+10
  ld a,242             ; EXIT MINE TO STONE BUILDING IN NARNIA
  makeexitdoor:
  ld (hl),a
  ld hl,tilemap2+190
  ld (hl),239           ; EXIT TO SAME STONE BUILDING
  jp tilefinished

buildroommine2reverse:
  call buildroommine
  ld hl,tilemap2+10
  ld a,240            ; EXIT MINE TO STONE BUILDING IN MAZE
  jr makeexitdoor