


resetdocks:
  ld a,b_dockempty
  ld (homedock_selfmod-1),a
  ld (medievaldock_selfmod-1),a
  ld (newworlddock_selfmod-1),a
  ld (faminedock_selfmod-1),a
  ld (forestlanddock_selfmod-1),a
ret

readcompasshelp: defb 0

setsail:
  ld a,0:hascompass ;(hascompass)
  or a
  jr nz,setsailnow

  ; CHECK FOR COMPASS
  ld b,29                 
  call checkplayerinvrand_cf
  jr c,dotakecompass

  ; COMPLAIN WE DON'T HAVE COMPASS
  ld a,(readcompasshelp)
  or a
  jr nz,displaycompasshelp2

  ld a,1
  ld (readcompasshelp),a
  ld l,s_ship_compass
  jp statusbarprintparagraphhl

  displaycompasshelp2:
  ld l,s_ship_compass3
  jp statusbarprintparagraphhl

  ; SHIP CAPTAIN TAKES COMPASS FROM PLAYER
  dotakecompass:
  call remplayerinvrand ; REMOVE COMPASS FROM RANDOM INVENTORY LIST
  ld a,1
  ld (hascompass-1),a
  ld l,s_ship_compass2
  jp statusbarprintparagraphhl            ; OUTPUT STRING
 
  setsailnow:
  ; CLEAR DOCKS
  call delleveldepth 
  call resetdocks

  ld l,s_ship_options
  call statusbarprintparagraphhl             ; OUTPUT STRING
  ld a,5 ; CHECK 1-3 KEYPRESS
  call waitoption_1_2_3_4_5ss

  rlca                  ; DOUBLE TWICE FOR LOOKUP OF FOUR BYTE STRING
  rlca
  ld hl,boatdesttable
  ld b,0
  ld c,a
  add hl,bc
  ld e,(hl)             ; LOAD SELF MODIFICATION LOCATION INTO DE
  inc hl
  ld d,(hl)
  ex de,hl
  ld (hl),b_dock        ; MOVE BOAT TO DESTINATION
  ex de,hl
  inc hl
  ld c,(hl)             ; LOAD MAP COORDINATES TO SAIL TO
  inc hl
  ld b,(hl)
  xor a                 ; EXIT SHIPld a,10 ; STAY IN SHIP
  jp setnewlocation
  
; MAP TILE FOR SELF MOD, MAP LOCATION IN BYTES
boatdesttable:
  defw newworlddock_selfmod-1,   &2F22 ; X = 34, Y = 47
  defw medievaldock_selfmod-1,   &4209 ; X = 9,  Y = 66
  defw homedock_selfmod-1,       &0301 ; X = 1,  Y = 3
  defw forestlanddock_selfmod-1, &385A ; X = 90, Y = 56
  defw faminedock_selfmod-1,     &6044 ; X = 68, Y = 96