; USE THIS CODE TO ASSEMBLE TILES.BIN FILE IN BASIC FOR 128k VERSION
; THEN
; SAVE "TILES.BIN",b,&4000,&2590 (or whatever the length is in ram)

;iswestern equ 1
;issnow equ 1
;iscart equ 1
;compilebinary equ 1
;is128k equ 1

nolist

; 64K
; ------------

ifndef compilebinary 
  ifndef is128k
    ifndef iscart
      read "tilegraphicstable.asm"
      read "tilegraphicsmain2.asm"
    endif
  endif
endif

; 128K OR CART
; ------------

ifdef compilebinary
  ifdef iscart
    org &C000 ; ACCESSING FROM START OF ROM
  endif
  ifdef is128k
    org &4000
  endif

  read "tilegraphicstable.asm"

  ; START GRAPHICS AT KNOWN ADDRESS TO MAKE IT EASIER TO RECOLOUR THEM PROGAMATICALLY
  ifdef iscart
    org &C200 ; ACCESSING FROM START OF ROM
  endif
  ifdef is128k
    org &4200
  endif

  read "tilegraphicsmain2.asm"

  ; THESE TILES ARE LOCATED IN MAIN CODE FOR WEAPONS, BUT ALSO NEED TO BE PICKABLE ITEMS ON GROUND
  ; FOR 128k, WE CAN UPDATE THE TABLE WITH ACTUAL GRAPHICS POINTERS
  ; THIS IS DONE IN BANKSWITCH.ASM
  ; FOR ROM, WE CAN'T MODIFY THE TABLE. BUT AS WE HAVE PLENTY OF SPACE ON ROM, WE MAKE A DUPLICATE
  ;ifdef is128k
  ;  pickaxeleft equ 0
  ;  arrowleft equ 0
  ;endif

  ; OUTPUT FILE TO DSK OR FOLDER
  ifdef iscart
    ifdef iswestern
      save "TILES002.bin",&C000,&4000
    endif
    ifdef issnow
      save "TILES001.bin",&C000,&4000
    endif
    ifndef iswestern
    ifndef issnow
      save "TILES.bin",&C000,&4000
    endif
    endif
  endif
  ifdef is128k
    save direct "TILES.BIN",&4000,&25F0
  endif
endif