; USE THIS CODE TO ASSEMBLE TILES.BIN FILE IN BASIC FOR 128k VERSION
; THEN
; SAVE "DICT.BIN",b,&4000,&0A80 (or whatever the length is in ram)

;iscart equ 1
;compilebinary equ 1
;is128k equ 1

nolist

ifndef compilebinary 
  ifndef is128k
    ifndef iscart
      read "dictionary.asm"            ; DICTIONARY
      read "dictionarystrings.asm"     ; DICTIONARY OF WORDS
      read "dictionarydefs.asm"        ; DEFINITIONS FOR 64k OR 128k
      read "dictionarystringsdefs.asm" ; DICTIONARY OF WORDS
    endif
  endif

  ifdef is128k
    stringstable equ &4000              ; DON'T READ, JUST POINT TO WHERE "dictionarystrings.asm" WILL BE   
    read "dictionary.asm"               ; DICTIONARY    
    read "dictionarydefs.asm"           ; DEFINITIONS FOR 64k OR 128k
    read "dictionarystringsdefs.asm"    ; DICTIONARY OF WORDS
  endif
  ifdef iscart
    stringstable equ &C000              ; DON'T READ, JUST POINT TO WHERE "dictionarystrings.asm" WILL BE
    ;read "dictionary.asm"               ; DICTIONARY
    read "dictionarydefs.asm"           ; DEFINITIONS FOR 64k OR 128k
    read "dictionarystringsdefs.asm"    ; DICTIONARY OF WORDS
  endif
endif

ifdef compilebinary
  ifdef iscart
     org &C000
  endif
  ifdef is128k
     org &4000
  endif

  read "dictionarystringsdefs.asm"
  read "dictionarydefs.asm"
  read "dictionarystrings.asm"

  ifdef iscart
    save "DICT.bin",&C000,&4000
  endif
  ifdef is128k
    save direct "DICT.BIN",&4000,&0600
  endif
endif