; INPUTS
; D = REPLACE BYTE 1
; E = REPLACE BYTE 2
ifndef iscart
createmygrass:
     ld de,&8C8A
     call changegrasstilecols
     ld de,&4C45
     jp changegrasstilecols

createmydirt:
     ld de,&8A8C
     call changegrasstilecols
     ld de,&454C
     changegrasstilecols:
     ld hl,g_grass
     call changecolonesprite
     ld hl,g_grass2
     jp changecolonesprite

; CLIMATE EFFECTS
; MODIFY SPRITE, CHANGE COLOUR OF PIXELS FROM GREEN TO WHITE OR VICE VERSA
makeallnotsnow:
  ld de,&C033          ; WHITE TO GREEN
  ld hl,g_mytree1      ; START SPRITE LOCATION
  ld b,6               ; 6 SPITES TO RECOLOUR
  call changecolloop

  ld de,&C0CF          ; WHITE TO GREEN
  ld hl,g_palmtopleft  ; START SPRITE LOCATION
  ld b,2               ; 2 SPITES TO RECOLOUR
  call changecolloop

  ld de,&C09B          ; WHITE TO GREEN
  ld hl,g_smallcactus  ; START SPRITE LOCATION
  ld b,5               ; 5 SPRITES TO RECOLOUR
  jr changecolloop

makeallsnow:
  ld de,&33C0          ; GREEN TO WHITE
  ld hl,g_mytree1      ; START SPRITE LOCATION
  ld b,6               ; 6 SPITES TO RECOLOUR
  call changecolloop

  ld de,&CFC0          ; WHITE TO GREEN
  ld hl,g_palmtopleft  ; START SPRITE LOCATION
  ld b,2               ; 2 SPITES TO RECOLOUR
  call changecolloop

  ld de,&9BC0          ; GREEN TO WHITE
  ld hl,g_smallcactus  ; START SPRITE LOCATION
  ld b,5               ; 5 SPRITES TO RECOLOUR
changecolloop:
  push bc
  call changecolonesprite
  pop bc
  djnz changecolloop
ret

endif

; INPUT
; HL = TILE BUFFER TO CLEAR
; BC = SIZE OF DATA TO CLEAR
clearmem:
  push hl
  dec bc
  push hl
  pop de
  inc de
  ld (hl),0
  ldir
  pop hl
ret