org &4000
jp start

AYRegWrite:
  push bc
    ld bc,&F4   ; #f4 reg num
    ld c,a
    out (c),c

    ld bc,&f6c0 ; select reg
    out (c),c

    ld bc,&f600 ; inactive
    out (c),c

    ld bc,&f680 ; write value
    out (c),c
  pop bc
 
  ld b,&f4      ; #f4 value
  out (c),c

  ld bc,&f600   ; inactive
  out (c),c
ret

AYMakeTone:
  ;*** these are incorrectly marked as Amplitude Control (Reg R10,R11,R12) in some documentation! ***
  ld a,h
  and %01000000	;-V------ = Volume bit
  rrca
  rrca
  rrca
  rrca
  or  %00001011	;Shift the high volume bit into position
  ld c,a
  ld a,9			;4-bit Volume / 2-bit Envelope Select for channel A ---EVVVV
  call AYRegWrite
ret

start:
  ; TURN ON NOISE FOR CHANNEL A
  ld a,7  ; MIXER
  ;%PPNNNTTT (1=OFF) --CBACBA

  ld c,%10110110
  call AYRegWrite

  ld a,6          ; Noise ---NNNNN
  ld c,%00001111
  call AYRegWrite
  call AYMakeTone
ret
