; USE THIS CODE TO ASSEMBLE TILES.BIN FILE IN BASIC FOR 128k VERSION
; THEN
; SAVE "SPRITES.BIN",b,&4000,&0AB0 (or whatever the length is in ram)


;iscart equ 1
;compilebinary equ 1
;is128k equ 1

nolist

; 64K
; ------------

ifndef compilebinary 
  ifndef is128k
    ifndef iscart
      read "spritegraphics4_table.asm"
      read "spritegraphics4.asm"
    endif
  endif
endif

; 128K OR CART
; ------------

ifdef compilebinary
  ifdef iscart
    org &C000 ; ACCESSING FROM START OF ROM
  endif
  ifdef is128k
    org &4000
  endif

  read "spritegraphics4_defs.asm"  
  read "spritegraphics4_table.asm"
  read "spritegraphics4.asm"
  ;read "spritegraphics4_defs.asm"
  read "definitions.asm"           ; DEFINITIONS FOR 64k OR 128k

  ; OUTPUT FILE TO DSK OR FOLDER
  ifdef iscart
    save "SPRITES.bin",&C000,&4000
  endif
  ifdef is128k
    save direct "SPRITES.BIN",&4000,&0B30
  endif
endif