; RANDOM FUNCTIONS FOR POSTER
posterfunctionslen equ 3
dorandompostertable:
  defw posterwantedwoman
  defw posterwantedman
  defw postermimo

displaywantedposter:
  call resetpseudorandomquest  ; MAKE SURE NAME STAYS SAME FOR WHOLE DAY FOR THIS LOCATION
  ld b,posterfunctionslen
  call randmax32
  ld hl,dorandompostertable
  jp vectortablelaunchcode

  postermimo:
  ld a,(bountyreward-1)        ; CHECK IF WE ARE WANTED, IF NOT, FIND ANOTHER NAME
  or a
  jr z,posterwantedman
  ; GET MIMO'S BOUNTY FOR THE POSTER
  ld bc,(bountyreward-2)
  ; GET MIMO'S COORDS FOR POSTER
  ld a,(ix+4)
  ld (wantedmanxcoord-1),a
  ld a,(ix+5)
  ld (wantedmanycoord-1),a
  ; GET MIMO'S NAME FOR THE POSTER
  ld a,(ix+20)              
   
  printwantedposter:
  ld (wantedmanname-1),a
  ld (posterreward-2),bc
  doprintwantedposteronly:
  ld hl,str_wantedposter
  jp printstronce

  posterwantedman:            
  ; IF WANTED MAN ALREADY GENERATED, DON'T REGENERATE DETAILS
  ld a,0:wantedmanalive   
  cp 3 ; WE KILLED HIM ALREADY
  jr z,posterwantedwoman     
  or a
  jr nz,doprintwantedposteronly

  ; GET A RANDOM TOWN COORDINATE TO USE FOR THIS QUEST
  call getrandtown_cf          ; L = X, H = Y               
  jr nc,posterwantedwoman      ; WE DON'T KNOW ANY TOWNS YET, JUST DISPLAY OTHER POSTERS
  ; STORE DETAILS OF WANTED MAN IN SLOT
  ld a,1                       ; SET WANTED MAN TO SPAWN
  ld (wantedmanalive-1),a
  ld a,l
  ld (wantedmanxcoord-1),a
  ld a,h
  ld (wantedmanycoord-1),a
  ; GENERATE WANTED MAN NAME FOR THIS TOWN
  call genrandommanname        
  ld bc,(currentwantedmanreward)
  jr printwantedposter

  posterwantedwoman:
  ld l,s_str_notwantedposter
  jp printstroncehl

currentwantedmanreward: defb 100,0  ; REWARD FOR OUTLAW
defb 0,0:bountyreward               ; REWARD FOR MIMO

str_gravestone:      defb 13,here," LIES",21,0:deadmanname ; DEAD MAN FIRST LAST NAME IN NIBBLES
                     defb 255
;str_wantedposter    defb "WANTED DEAD OR ALIVE",10,12
;                     defb 21,0wantedmanname ; WANTED MAN FIRST LAST NAME IN NIBBLES
;                     defb 10,"$",17,0,0posterreward
;                     defb " REWAR","D"+&80;,255
;str_notwantedposter defb "WANTED WOMAN WHO ",13,can,"COOK,",10,"CLEAN",13,andd,"MEND SOCKS",255
   
outlawfirstnameslen equ 9
; MIMO'S NAME IS AT END OF LIST SO IT CAN'T BE USED FOR OTHER SPRITES - EG %01100110 = 4,4
outlawfirstnames:
  defw str_bad
  defw str_mad
  defw str_cactus
  defw str_redneck
  defw str_crazy
  defw str_wild
  defw str_sleepy
  defw str_happy
  defw dict_peaceful
  defw str_mimo

str_bad:     defb "BA","D"+&80;,255
str_mad:     defb "MA","D"+&80;,255
str_cactus:  defb "CACTU","S"+&80;,255
str_redneck: defb "REDNEC","K"+&80;,255
str_crazy:   defb "CRAZ","Y"+&80;,255
str_wild:    defb "WIL","D"+&80;,255

outlawlastnames:
  defw str_bert
  defw str_jack
  defw str_magee
  defw str_ned
  defw str_fred
  defw str_bill
  defw str_james
  defw str_sandy
  defw str_joe
  defw str_empty

str_bert:  defb "BER","T"+&80;,255
str_jack:  defb "JAC","K"+&80;,255
str_magee: defb "MAGE","E"+&80;,255
str_ned:   defb "NE","D"+&80;,255
str_fred:  defb "FRE","D"+&80;,255
str_bill:  defb "BIL","L"+&80;,255
str_joe:   defb "JO","E"+&80;,255

; GET A RANDOM OUTLAW NAME INTO DE
; OUTPUT
; DE = PTR TO RANDOM OUTLAW NAME
;getrandoutlawname
;   ; USE STR_TEMP TO GENERATE TOWN NAME TEXT
;   ld de,str_temp
;   push de
;   ; GET RANDOM NAME
;   ld b,outlawfirstnameslen
;   call randmax
;   ld hl,outlawfirstnames
;   call vectorlookuphl
;   ; GET FIRST NAME INTO DE
;   call copystr;

;   ; COPY SECOND RANDOM NAME
;   ld b,outlawlastnameslen
;   call randmax
;   ld hl,outlawlastnames
;   call vectorlookuphl
;   ; COPY 255 MARKER
;   call copystr2 
;   pop de
;ret


